-- import dependencies
require( "LUList" )
require( "LUMap" )

local anObject = LUObject.new()
local anotherObject = LUObject.new()

print( tostring( LUObject ) )
print( tostring( anObject ) )
print( tostring( anotherObject ) )
print( "LUObject.hashCode: "..LUObject.hashCode() )
print( "LUObject.toString(): "..LUObject.toString() )
print( "anObject.hashCode(): "..anObject.hashCode() )
print( "anotherObject.hashCode(): "..anotherObject.hashCode() )
print( "anObject.self().toString(): "..anObject.self().toString() )
print( "anObject.class().toString(): ".. anObject.class().toString() )
print( "equals: "..tostring( anObject.equals( anObject.self() ) ) )
print( "equals: "..tostring( anObject.equals( anObject.class() ) ) )
print( "equals: "..tostring( anObject.class().equals( anObject.class() ) ) )
print( "equals: "..tostring( anObject.class().equals( anObject ) ) )

print( tostring( anObject ) )
print( type( anObject ) )

local aList = LUList.new()

print( "LUList.hashCode: "..LUList.hashCode() )
print( "aList.hashCode: "..aList.hashCode() )

aList.add( anObject );
aList.add( anotherObject );
aList.add( "aString" );
aList.add( true );
aList.add( false );
aList.add( 10 );
aList.add( function() end );
aList.add( {} );

print( "aList.get: "..aList.get( anObject ).toString() )
print( "aList.get: "..aList.get( 1 ).toString() )
print( "aList.get: "..tostring( aList.get( true ) ) )
print( "aList.size: "..aList.size() )
print( "aList.toString: "..aList.toString() )

aList.remove( anObject );

print( "aList.size: "..aList.size() )

aList.remove( anotherObject );

print( "aList.size: "..aList.size() )

print( "aList.equals: "..tostring( aList.equals( aList ) ) )

local anotherList = LUList.new()

print( "anotherList.equals: "..tostring( anotherList.equals( aList ) ) )

anotherList.addAll( aList )

print( "anotherList.hashCode: "..anotherList.hashCode() )
print( "anotherList.equals: "..tostring( anotherList.equals( aList ) ) )

local aMap = LUMap.new()

print( "LUMap.hashCode: "..LUMap.hashCode() )
print( "aMap.class().hashCode: "..aMap.class().hashCode() )
print( "aMap.hashCode: "..aMap.hashCode() )

aMap.put( "aKey", "aValue" )
aMap.put( 1, true )
aMap.put( 2, false )
aMap.put( true, false )
aMap.put( anObject, anObject )

aMap.put( anObject, nil )

print( "aMap.size: "..aMap.size() )
print( "aMap.toString: "..aMap.toString() )
print( "aMap.keys: "..aMap.keys().toString() )
print( "aMap.values: "..aMap.values().toString() )

local anotherMap = LUMap.new()

anotherMap.putAll( aMap )
anotherMap.put( "anotherKey", "anotherValue" )

print( "anotherMap.keys: "..anotherMap.keys().toString() )
print( "anotherMap.values: "..anotherMap.values().toString() )
print( "anotherMap.equals: "..tostring( anotherMap.equals( aMap ) ) )

