--------------------------------------------------------------------------------
-- Title:               MyClass.lua
-- Description:         Like a square peg in a round hole
-- Author:              Raphaël Szwarc http://alt.textdrive.com/lua/
-- Creation Date:       February 1, 2005
-- Legal:               Copyright (C) 2005 Raphaël Szwarc
--------------------------------------------------------------------------------

-- import dependencies
require( "LUObject" )

-- super class
local superClass = LUObject

-- inherit the super class methods
local thisClass = superClass.inherit( superClass )

-- factory class method, this is where all the instance methods are implemented as closures
thisClass.new = function()
        -- instantiate the super class
        local super = superClass.new()
        
        -- inherit the super class instance methods
        local this = super.class().inherit( super )
        
        -- local table for the instance variables
        local ivars = {}

        -- instance method 
        this.justDoIt = function()
                return true
        end

        -- return the public instance methods
        return this
end

-- instance method 
thisClass.doIt = function()
        return true
end

-- define the class name
MyClass = thisClass

return MyClass